#if !defined( _JCSVFileWriterObj_h )
#define _JCSVFileWriterObj_h
#include "JAddObj.h"
#include "JCriticalSection.h"
#include "JFile.h"
#include "JFileOutputStream.h"

#include <stdio.h>
#define MAX_INPUTS 40

class 
#if defined(_EXTERNAL_DLL)
  DllExport
#else
  DllImport 
#endif
JCSVFileWriterObj : public JAddObj {
  protected:
    virtual void writeContent(class JOutputStream& os);
    virtual void readContent(class JDictionary& dict);
  public:
    enum {
      ON,
      TICK };

    virtual const char* className() const;
    virtual JObject* clone() const;
    JCSVFileWriterObj();
    virtual void draw(JGraphics g, int x, int y, int w, int h);
    virtual boolean inputAllowed(int n);
    virtual JString inputTag(int n);
    virtual JString outputTag(int n);
    virtual JFRect inputArea(int n);
    virtual JFRect outputArea(int n);
    virtual int inputFace(int n);
    virtual int outputFace(int n);
    virtual JFPoint inputPoint(int n, JLinkObj& link);
    virtual JFPoint outputPoint(int n, JLinkObj& link);
    virtual void engine(int n, JLinkObj& link);
    virtual JArray getProperties();
    virtual boolean updateProperty(JProperty& prop);
    virtual void access(int n, JLinkObj& link, const JDataType& data);

	virtual int outputType( int n );
	virtual int inputType( int n );
  private:

    // controls
    int on;
    int counter;
	int writeCounter;

    // properties
    JString file;
	int writeAfter;

	JFile outFile;
	FILE* outputStream;
	int outStreamAvailable;

    // inputs
    int r0;
    int rin[MAX_INPUTS];
};


#endif
